<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  admin_articles_category.php                              ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/tree.php");
	include_once ($root_folder_path . "includes/friendly_functions.php");

	check_admin_security("articles");

 	$t = new VA_Template($settings["admin_templates_dir"]);
 	$t->set_file("main","admin_articles_category.html");

	$t->set_var("admin_articles_top_href",      "admin_articles_top.php");
	$t->set_var("admin_articles_category_href", "admin_articles_category.php");
	$t->set_var("admin_select_href",   "admin_select.php");
	$t->set_var("admin_upload_href",   "admin_upload.php");
	$t->set_var("admin_articles_href", "admin_articles.php");

	$category_id = get_param("category_id");

	$r = new VA_Record($table_prefix . "articles_categories");
	
	$r->add_where("category_id", INTEGER);
	$r->add_textbox("category_order", TEXT, "Category order");
	$r->change_property("category_order", REQUIRED, true);
	$r->add_textbox("total_views", INTEGER);
	$r->change_property("total_views", USE_IN_INSERT, false);
	$r->change_property("total_views", USE_IN_UPDATE, false);
	$r->add_textbox("category_name", TEXT, "Category name");
	$r->change_property("category_name", REQUIRED, true);
	$r->change_property("category_name", MAX_LENGTH, 255);
	$r->add_textbox("friendly_url", TEXT, "Friendly URL");
	$r->change_property("friendly_url", USE_SQL_NULL, false);
	$r->change_property("friendly_url", BEFORE_VALIDATE, "validate_friendly_url");
	$r->add_textbox("articles_list_template", TEXT);
	$r->add_textbox("articles_details_template", TEXT);

	$r->add_checkbox("is_rss", INTEGER);
	$r->add_checkbox("rss_on_breadcrumb", INTEGER);
	$r->add_checkbox("rss_on_list", INTEGER);
	$r->add_textbox("rss_limit", TEXT);

	$order_columns = array(
		array("", ""), array("article_order", "Order Column"), 
		array("article_date", "Date"), array("date_end", "Date End"),
		array("article_title", "Title"), array("author_name", "Author Name"),
		array("date_added", "Date Added"), array("date_updated", "Date Updated")
	);
	$r->add_select("articles_order_column", TEXT, $order_columns);
	$order_directions = array(array("", ""), array("ASC", "Ascending"), array("DESC", "Descending"));
	$r->add_select("articles_order_direction", TEXT, $order_directions);

	$r->add_textbox("article_list_fields", TEXT);
	$r->add_textbox("article_details_fields", TEXT);
	$r->add_textbox("article_required_fields", TEXT);

	$allowed_values = array(array("0", "Nobody"), array("1", "All users"), array("2", "Only registered users"));
	$allowed_values = array(array("0", "Nobody"), array("1", "All users"));
	$r->add_radio("allowed_view", INTEGER, $allowed_values, "Allow view articles");
	$r->add_checkbox("allowed_post", INTEGER);
	$r->change_property("allowed_post", SHOW, false);
	$r->add_checkbox("allowed_rate", INTEGER);
	$r->add_textbox("short_description", TEXT);
	$r->add_textbox("full_description", TEXT);

	$r->add_textbox("image_small", TEXT);
	$r->add_textbox("image_small_alt", TEXT);
	$r->add_textbox("image_large", TEXT);
	$r->add_textbox("image_large_alt", TEXT);

	$r->add_textbox("meta_title", TEXT);
	$r->add_textbox("meta_keywords", TEXT);
	$r->add_textbox("meta_description", TEXT);

	$r->add_textbox("parent_category_id", TEXT);
	$r->change_property("parent_category_id", USE_IN_UPDATE, false);
	$r->add_textbox("category_path", TEXT);
	$r->change_property("category_path", USE_IN_UPDATE, false);

	//$r->add_checkbox("is_contents", INTEGER, "Show category contents");
	//$r->add_checkbox("is_list", INTEGER);
	//$r->add_textbox("moderators_ids", TEXT, "Moderators");
	//$r->add_checkbox("is_hot", INTEGER, "Show on main page");
	//$r->add_textbox("alias_category_id", TEXT);
	//$r->change_property("alias_category_id", USE_IN_UPDATE, false);
	//$r->add_textbox("language_code", TEXT, "Language code");
	//$r->change_property("language_code", MAX_LENGTH, 2);
	$r->add_hidden("total_articles", INTEGER);
	$r->change_property("total_articles", USE_IN_INSERT, true);
	$r->add_hidden("total_subcategories", INTEGER);
	$r->change_property("total_subcategories", USE_IN_INSERT, true);

	$r->get_form_values();

	$article_fields = array(
		"article_date", "date_end", "article_title", "author_name", "author_email", 
		"author_url", "link_url", "download_url", "short_description", "full_description",
		"image_small", "image_large", "keywords", "notes"
	);

	if(!strlen($r->get_value("parent_category_id"))) $r->set_value("parent_category_id", "0");
	$parent_category_id = $r->get_value("parent_category_id");

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "tree", "");
	$tree->show($parent_category_id);

	$list_fields = ""; $details_fields = ""; $required_fields = "";
	$operation = get_param("operation");
	if ($parent_category_id > 0) {
		$return_page = "admin_articles.php?category_id=" . $parent_category_id;
	} else {
		$return_page = "admin_articles_top.php";
	}
	if(strlen($operation))
	{
		$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "");

		if ($operation == "cancel") {
			header("Location: " . $return_page);
			exit;
		} else if($operation == "delete" && $r->get_value("category_id")) {
			$categories = "";
			$category_path = $tree->get_path($category_id);
			$sql  = " SELECT category_id FROM " . $table_prefix . "articles_categories ";
			$sql .= " WHERE category_id = " . $db->tosql($category_id, INTEGER);
			$sql .= " OR category_path LIKE '" . $db->tosql($category_path, TEXT, false) . "%'";
			$db->query($sql);
			while($db->next_record())
				$categories[] = $db->f("category_id");

			if(is_array($categories)) {
				for($i = 0; $i < sizeof($categories); $i++) {
					$db->query("DELETE FROM " . $table_prefix . "articles_assigned WHERE category_id = " . $db->tosql($categories[$i], INTEGER));
					$db->query("DELETE FROM " . $table_prefix . "articles_categories WHERE category_id=" . $db->tosql($categories[$i], INTEGER));
				}
			}
			if ($parent_category_id) {
				$db->query("UPDATE " . $table_prefix . "articles_categories SET total_subcategories = total_subcategories - 1 WHERE category_id = " . $db->tosql($parent_category_id, INTEGER));
			}
	
			header("Location: " . $return_page);
			exit;
		} 

		if ($r->get_value("parent_category_id") == 0) {
			for($i = 0; $i < sizeof($article_fields); $i++) {
				$field_name = $article_fields[$i];
				if(get_param("list_" . $field_name) == 1) {
					if ($list_fields) { $list_fields .= ","; }
					$list_fields .= $field_name; 
				}
				if(get_param("details_" . $field_name) == 1) {
					if ($details_fields) { $details_fields .= ","; }
					$details_fields .= $field_name;
				}
				if(get_param("required_" . $field_name) == 1) {
					if ($required_fields) { $required_fields .= ","; }
					$required_fields .= $field_name; 
				}

			}
			$r->set_value("article_list_fields", $list_fields);
			$r->set_value("article_details_fields", $details_fields);
			$r->set_value("article_required_fields", $required_fields);

			$category_order = get_db_value("SELECT MAX(category_order) FROM " . $table_prefix . "articles_categories WHERE parent_category_id=" . $db->tosql($parent_category_id, INTEGER));
			$category_order++;
			$r->set_value("category_order", $category_order);
		}

		$is_valid = $r->validate();
		
		if($is_valid)
		{
			if(strlen($r->get_value("category_id"))) {
				set_friendly_url();
				$record_updated = $r->update_record();
			}	else {
				set_friendly_url();
				$r->set_value("category_path", $tree->get_path($r->get_value("parent_category_id")));
				$r->set_value("total_articles", 0);
				$r->set_value("total_subcategories", 0);
				$record_updated = $r->insert_record();
				if ($parent_category_id && $record_updated) {
					$db->query("UPDATE " . $table_prefix . "articles_categories SET total_subcategories = total_subcategories + 1 WHERE category_id = " . $db->tosql($parent_category_id, INTEGER));
				}
			}
			if ($record_updated) {
				header("Location: " . $return_page);
				exit;
			}
		}
	} else if(strlen($r->get_value("category_id"))) { // edit existing category
		$r->get_db_values();
		$list_fields = $r->get_value("article_list_fields");
		$details_fields = $r->get_value("article_details_fields");
		$required_fields = $r->get_value("article_required_fields");
	} else { // new category - set default values
		$category_order = get_db_value("SELECT MAX(category_order) FROM " . $table_prefix . "articles_categories WHERE parent_category_id=" . $db->tosql($parent_category_id, INTEGER));
		$category_order++;
		$r->set_value("category_order", $category_order);
		$r->set_value("allowed_view", 1);
		$r->set_value("allowed_rate", 1);
		$list_fields = "article_date,article_title,image_small,short_description";
		$details_fields = "article_date,article_title,image_large,full_description";
		$required_fields = "article_date,article_title";
	}

	if ($r->get_value("parent_category_id") == 0) {
		$list_fields = ",," . $list_fields . ",,";
		$details_fields = ",," . $details_fields . ",,";
		$required_fields = ",," . $required_fields . ",,";
		for ($i = 0; $i < sizeof($article_fields); $i++) {
			$field_name = $article_fields[$i];
			if (strpos($list_fields, "," . $field_name . ",")) {
				$t->set_var("list_" . $field_name, "checked");
			} else {
				$t->set_var("list_" . $field_name, "");
			}
			if (strpos($details_fields, "," . $field_name . ",")) {
				$t->set_var("details_" . $field_name, "checked");
			} else {
				$t->set_var("details_" . $field_name, "");
			}
			if (strpos($required_fields, "," . $field_name . ",")) {
				$t->set_var("required_" . $field_name, "checked");
			} else {
				$t->set_var("required_" . $field_name, "");
			}
		}
	}
	$r->set_parameters();

	if ($r->get_value("parent_category_id") == 0) {
		$t->parse("layout_properties", false);
	} else {
		$t->set_var("layout_properties", "");
	}


	if(strlen($category_id)) {
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else {
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>