<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                       ***
  ***      File:  admin_orders_recurring.php                               ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	@set_time_limit (300);
	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/parameters.php");
	include_once ($root_folder_path . "includes/shopping_cart.php");
	include_once ($root_folder_path . "includes/order_links.php");
	include_once ($root_folder_path . "includes/order_items.php");
	include_once ($root_folder_path . "messages/".$language_code."/cart_messages.php");

	check_admin_security("create_orders");

	// settings for errors notifications 
	$eol = get_eol();
	$recipients     = $settings["admin_email"];
	$email_headers  = "From: " . $settings["admin_email"] . $eol;
	$email_headers .= "Content-Type: text/plain";
	$recurring_errors = ""; $recurring_success = ""; $orders_added = 0;

	// initiliaze template if it doesn't exists
	if (!isset($t)) {
		$t = new VA_Template($settings["admin_templates_dir"]);
	}

	// Database Initialize
	$db = new VA_SQL();
	$db->DBType      = $db_type;
	$db->DBDatabase  = $db_name;
	$db->DBHost      = $db_host;
	$db->DBPort      = $db_port;
	$db->DBUser      = $db_user;
	$db->DBPassword  = $db_password;
	$db->DBPersistent= $db_persistent;

	// Database Initialize
	$dbi = new VA_SQL();
	$dbi->DBType      = $db_type;
	$dbi->DBDatabase  = $db_name;
	$dbi->DBHost      = $db_host;
	$dbi->DBPort      = $db_port;
	$dbi->DBUser      = $db_user;
	$dbi->DBPassword  = $db_password;
	$dbi->DBPersistent= $db_persistent;

	$order_params = array(
		"user_id" => INTEGER, "payment_id" => INTEGER, "visit_id" => INTEGER,
		"remote_address" => TEXT, "initial_ip" => TEXT, "cookie_ip" => TEXT,
		"affiliate_code" => TEXT, "affiliate_user_id" => INTEGER, "keywords" => TEXT,
		"coupons_ids" => TEXT, "currency_code" => TEXT, "keywords" => TEXT,
		"tax_name" => TEXT, "tax_percent" => NUMBER, "tax_total" => NUMBER,
		"name" => TEXT, "first_name" => TEXT, "last_name" => TEXT,
		"company_id" => INTEGER, "company_name" => TEXT, "email" => TEXT,
		"address1" => TEXT, "address2" => TEXT, "city" => TEXT,
		"province" => TEXT, "state_code" => TEXT, "zip" => TEXT,
		"country_code" => TEXT, "phone" => TEXT, "daytime_phone" => TEXT,
		"evening_phone" => TEXT, "cell_phone" => TEXT, "fax" => TEXT,
		"delivery_name" => TEXT, "delivery_first_name" => TEXT, "delivery_last_name" => TEXT,
		"delivery_company_id" => INTEGER, "delivery_company_name" => TEXT, "delivery_email" => TEXT,
		"delivery_address1" => TEXT, "delivery_address2" => TEXT, "delivery_city" => TEXT,
		"delivery_province" => TEXT, "delivery_state_code" => TEXT, "delivery_zip" => TEXT,
		"delivery_country_code" => TEXT, "delivery_phone" => TEXT, "delivery_daytime_phone" => TEXT,
		"delivery_evening_phone" => TEXT, "delivery_cell_phone" => TEXT, "delivery_fax" => TEXT,
		"cc_name" => TEXT, "cc_first_name" => TEXT, "cc_last_name" => TEXT,
		"cc_number" => TEXT, "cc_start_date" => DATETIME, "cc_expiry_date" => DATETIME,
		"cc_type" => INTEGER, "cc_issue_number" => INTEGER, "cc_security_code" => TEXT,
		"pay_without_cc" => TEXT
	);
  //success_message, pending_message, error_message
	$r = new VA_Record($table_prefix . "orders");

	$r->add_where("order_id", INTEGER);
	$r->add_textbox("parent_order_id", INTEGER);
	$r->add_textbox("transaction_id", TEXT);

	$r->add_textbox("currency_rate", NUMBER);
	$r->add_textbox("order_status", INTEGER);
	$r->set_value("order_status", 0);
	$r->add_textbox("total_buying", NUMBER);
	$r->add_textbox("total_merchants_commission", NUMBER);
	$r->add_textbox("total_affiliate_commission", NUMBER);

	$r->add_textbox("goods_total", NUMBER);
	$r->add_textbox("goods_taxable", NUMBER);
	$r->add_textbox("total_quantity", INTEGER);
	$r->add_textbox("weight_total", NUMBER);
	$r->add_textbox("total_discount", NUMBER);
	$r->add_textbox("total_discount_tax", NUMBER);

	$r->add_textbox("shipping_type_id", INTEGER);
	$r->add_textbox("shipping_type_desc", TEXT);
	$r->add_textbox("shipping_cost", NUMBER);
	$r->add_textbox("shipping_taxable", INTEGER);
	$r->add_textbox("shipping_tracking_id", TEXT);
	$r->add_textbox("shipping_expecting_date", DATETIME);

	$r->add_textbox("properties_total", NUMBER);
	$r->add_textbox("properties_taxable", NUMBER);

	$r->add_textbox("processing_fee", NUMBER);
	$r->add_textbox("order_total", NUMBER);
	$r->add_textbox("order_placed_date", DATETIME);

	$r->add_textbox("modified_date", DATETIME);

	$r->add_textbox("is_placed", INTEGER);
	$r->set_value("is_placed", 0);
	$r->add_textbox("is_exported", INTEGER);
	$r->set_value("is_exported", 0);
	$r->add_textbox("is_call_center", INTEGER);
	$r->set_value("is_call_center", 0);
	$r->add_textbox("is_recurring", INTEGER);
	$r->set_value("is_recurring", 1);

	foreach ($order_params as $parameter_name => $parameter_type) {
		$r->add_textbox($parameter_name, $parameter_type);
	}
	$r->change_property("visit_id", USE_SQL_NULL, false);
	$r->change_property("affiliate_code", USE_SQL_NULL, false);
	$r->change_property("affiliate_user_id", USE_SQL_NULL, false);
	$r->change_property("keywords", USE_SQL_NULL, false);
	$r->change_property("name", USE_SQL_NULL, false);
	$r->change_property("first_name", USE_SQL_NULL, false);
	$r->change_property("last_name", USE_SQL_NULL, false);
	$r->change_property("email", USE_SQL_NULL, false);

	// order items fields
	$oi = new VA_Record($table_prefix . "orders_items");
	$oi->add_where("order_item_id", INTEGER);
	$oi->add_textbox("parent_order_item_id", INTEGER);
	$oi->add_textbox("order_id", INTEGER);
	$oi->add_textbox("item_id", INTEGER);
	$oi->add_textbox("parent_item_id", INTEGER);
	$oi->add_textbox("item_user_id", INTEGER);
	$oi->change_property("item_user_id", USE_SQL_NULL, false);
	$oi->add_textbox("affiliate_user_id", INTEGER);
	$oi->change_property("affiliate_user_id", USE_SQL_NULL, false);
	$oi->add_textbox("item_type_id", INTEGER);
	$oi->add_textbox("manufacturer_code", TEXT);
	$oi->add_textbox("coupons_ids", TEXT);
	$oi->add_textbox("item_status", INTEGER);
	$oi->set_value("item_status", 0);
	$oi->add_textbox("item_name", TEXT);
	$oi->add_textbox("item_properties", TEXT);
	$oi->add_textbox("buying_price", NUMBER);
	$oi->add_textbox("real_price", NUMBER);
	$oi->add_textbox("discount_amount", NUMBER);
	$oi->add_textbox("price", NUMBER);
	$oi->add_textbox("tax_free", INTEGER);
	$oi->add_textbox("tax_percent", NUMBER);
	$oi->add_textbox("merchant_commission", NUMBER);
	$oi->add_textbox("affiliate_commission", NUMBER);
	$oi->add_textbox("weight", NUMBER);
	$oi->add_textbox("quantity", NUMBER);
	$oi->add_textbox("downloadable", NUMBER);
	$oi->add_textbox("shipping_expecting_date", DATETIME);
	// recurring fields
	$oi->add_textbox("is_recurring", INTEGER);
	$oi->set_value("is_recurring", 0);
	$oi->add_textbox("recurring_period", INTEGER);
	$oi->add_textbox("recurring_interval", INTEGER);
	$oi->add_textbox("recurring_payments_total", INTEGER);
	$oi->add_textbox("recurring_payments_made", INTEGER);
	$oi->add_textbox("recurring_payments_failed", INTEGER);
	$oi->add_textbox("recurring_end_date", DATETIME);
	$oi->add_textbox("recurring_last_payment", DATETIME);
	$oi->add_textbox("recurring_next_payment", DATETIME);
	$oi->add_textbox("recurring_plan_payment", DATETIME);

	$error_message = ""; $success_message = "";
	$last_order_id = ""; $order_items = array();

	$sql  = " SELECT oi.* ";
	$sql .= " FROM (" . $table_prefix . "orders_items oi ";
	$sql .= " LEFT JOIN " . $table_prefix . "order_statuses os ON os.status_id=oi.item_status) ";
	$sql .= " WHERE oi.is_recurring=1 ";
	$sql .= " AND os.paid_status=1 ";
	$sql .= " AND oi.recurring_next_payment IS NOT NULL ";
	$sql .= " AND oi.recurring_next_payment<=" . $dbi->tosql(va_time(), DATE);
	$sql .= " ORDER BY oi.order_id ";
	$dbi->query($sql);
	if ($dbi->next_record()) {
		$last_order_id = $dbi->f("order_id");
		do {
			$order_id = $dbi->f("order_id");

			if ($order_id != $last_order_id && sizeof($order_items) > 0) {
				recurring_order($last_order_id, $order_items);
			}

			$order_item_id = $dbi->f("order_item_id");
			$recurring_period = $dbi->f("recurring_period");
			$recurring_interval = $dbi->f("recurring_interval");
			$recurring_payments_total = $dbi->f("recurring_payments_total");
			$recurring_payments_made = $dbi->f("recurring_payments_made");
			$recurring_payments_failed = $dbi->f("recurring_payments_failed");
			$recurring_end_date = $dbi->f("recurring_end_date", DATETIME);
			$recurring_last_payment = $dbi->f("recurring_last_payment", DATETIME);
			$recurring_next_payment = $dbi->f("recurring_next_payment", DATETIME);
			$recurring_plan_payment = $dbi->f("recurring_plan_payment", DATETIME);

			$recurring_plan_ts = 0; $recurring_next_ts = 0; $recurring_end_ts = 0;
			if (is_array($recurring_next_payment)) {
				$recurring_next_ts = mktime (0, 0, 0, $recurring_next_payment[MONTH], $recurring_next_payment[DAY], $recurring_next_payment[YEAR]);
			}
			if (is_array($recurring_plan_payment)) {
				$recurring_plan_ts = mktime (0, 0, 0, $recurring_plan_payment[MONTH], $recurring_plan_payment[DAY], $recurring_plan_payment[YEAR]);
			}
			if (is_array($recurring_end_date)) {
				$recurring_end_ts = mktime (0, 0, 0, $recurring_end_date[MONTH], $recurring_end_date[DAY], $recurring_end_date[YEAR]);
			}
			if ((!$recurring_payments_total || $recurring_payments_total > $recurring_payments_made) &&
				(!$recurring_end_ts || $recurring_end_ts >= $recurring_plan_ts))
			{
				$order_items[] = array(
					"order_id" => $dbi->f("order_id"), 
					"order_item_id" => $dbi->f("order_item_id"),
					"item_id" => $dbi->f("item_id"),
					"item_user_id" => $dbi->f("item_user_id"),
					"affiliate_user_id" => $dbi->f("affiliate_user_id"),
					"parent_item_id" => $dbi->f("parent_item_id"),
					"item_type_id" => $dbi->f("item_type_id"),
					"manufacturer_code" => $dbi->f("manufacturer_code"),
					"coupons_ids" => $dbi->f("coupons_ids"),
					"item_name" => $dbi->f("item_name"),
					"item_properties" => $dbi->f("item_properties"),
					"buying_price" => $dbi->f("buying_price"),
					"real_price" => $dbi->f("real_price"),
					"discount_amount" => $dbi->f("discount_amount"),
					"affiliate_commission" => $dbi->f("affiliate_commission"),
					"merchant_commission" => $dbi->f("merchant_commission"),
					"price" => $dbi->f("price"),
					"tax_free" => $dbi->f("tax_free"),
					"tax_percent" => 0,
					"weight" => $dbi->f("weight"),
					"quantity" => $dbi->f("quantity"),
					"downloadable" => $dbi->f("downloadable"),
					"recurring_period" => $recurring_period,
					"recurring_interval" => $recurring_interval,
					"recurring_payments_total" => $recurring_payments_total,
					"recurring_payments_made" => $recurring_payments_made,
					"recurring_payments_failed" => $recurring_payments_failed,
					"recurring_end_date" => $recurring_end_date,
					"recurring_last_payment" => $recurring_last_payment,
					"recurring_next_payment" => $recurring_next_payment,
					"recurring_plan_payment" => $recurring_plan_payment
				);
			} else {
				// cancel recurring payments if the end date passed or all payments made
				$sql  = " UPDATE " . $table_prefix . "orders_items ";
				$sql .= " SET is_recurring=0 ";
				$sql .= " WHERE order_item_id=" . $db->f($order_item_id, INTEGER);
				$db->query($sql);
			}

			$last_order_id = $order_id;
		} while ($dbi->next_record());

		// add last order data
		if (sizeof($order_items) > 0) {
			recurring_order($last_order_id, $order_items);
		}
	}

	if ($orders_added) {
		$recurring_success = $orders_added . " recurring orders were added.";
	} else if (!$recurring_errors) {
		$recurring_success = "No recurring orders are available at present time.";
	}


function recurring_order($parent_order_id)
{
	global $db, $table_prefix, $db_type;
	global $t, $r, $order_params, $oi, $order_items;
	global $eol, $settings, $recipients, $email_headers;
	global $root_folder_path, $datetime_show_format;
	global $recurring_errors, $recurring_success, $orders_added;

	$recurring_error = false;

	$sql = " SELECT * FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($parent_order_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$r->set_value("parent_order_id", $parent_order_id);
		foreach ($order_params as $parameter_name => $parameter_type) {
			$r->set_value($parameter_name, $db->f($parameter_name, $parameter_type));
		}
		$email = $r->get_value("email");
		$delivery_email = $r->get_value("delivery_email");;
		$user_email = strlen($email) ? $email : $delivery_email;

		$r->set_value("coupons_ids", "");
		// check payment settings
		$sql  = " SELECT * FROM " . $table_prefix . "payment_systems ";
		$sql .= " WHERE payment_id=" . $db->tosql($r->get_value("payment_id"), INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$payment_name = $db->f("payment_name");
			$processing_time = $db->f("processing_time");
			$processing_fee = $db->f("processing_fee");
			$fee_type = $db->f("fee_type");
			$fee_min_goods = $db->f("fee_min_goods");
			$fee_max_goods = $db->f("fee_max_goods");
			$recurring_method = $db->f("recurring_method");
			$is_advanced = $db->f("is_advanced");
			$advanced_url = $db->f("advanced_url");
			$advanced_php_lib = $db->f("advanced_php_lib");
			$success_status_id = $db->f("success_status_id");
			$pending_status_id = $db->f("pending_status_id");
			$failure_status_id = $db->f("failure_status_id");
			$is_active = $db->f("is_active");
			if (!$recurring_method) {
				$recurring_error = true;
				$error_subject = "RECURRING PAYMENT ERROR";
				$error_body = "Payment system '" . $payment_name . "' is not allowed for recurring payments." . $eol;
			}
		} else {
			$recurring_error = true;
			$error_subject = "RECURRING PAYMENT ERROR";
			$error_body = "Payment system wasn't found in database." . $eol;
		}

		if (!$recurring_error) {

			// recurring settings
			$recurring_settings = array();
			$setting_type = "recurring_" . $r->get_value("payment_id");
			$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql($setting_type, TEXT);
			$db->query($sql);
			while($db->next_record()) {
				$recurring_settings[$db->f("setting_name")] = $db->f("setting_value");
			}

			$currency = get_currency($r->get_value("currency_code"));
			$currency_left = $currency["left"];
			$currency_right = $currency["right"];
			$currency_rate = $currency["rate"];
			$currency_code = $currency["code"];
			$currency_value = $currency["value"];
			$r->set_value("currency_code", $currency_code);
			$r->set_value("currency_rate", $currency_rate);

			// check user tax free option
			$tax_free = false;
			if ($r->get_value("user_id")) {
				$sql  = " SELECT u.tax_free AS user_tax_free, ut.tax_free AS group_tax_free ";
				$sql .= " FROM (" . $table_prefix . "users u ";
				$sql .= " LEFT JOIN " . $table_prefix . "user_types ut ON u.user_type_id=ut.type_id) ";
				$sql .= " WHERE user_id=" . $db->tosql($r->get_value("user_id"), INTEGER);
				$db->query($sql);
				if ($db->next_record()) {
					$user_tax_free = $db->f("user_tax_free");
					$group_tax_free = $db->f("group_tax_free");
					$tax_free = ($user_tax_free || $group_tax_free);
				}
			}

			// check main delivery details
			if ($r->get_value("delivery_country_code")) {
				$country_code = $r->get_value("delivery_country_code");
			} else {
				$country_code = $r->get_value("country_code");
			}
			if ($r->get_value("delivery_state_code")) {
				$state_code = $r->get_value("delivery_state_code");
			} else {
				$state_code = $r->get_value("state_code");
			}
			if ($r->get_value("delivery_zip")) {
				$postal_code = $r->get_value("delivery_zip");
			} else {
				$postal_code = $r->get_value("zip");
			}

			// VAT validation
			$vat_parameter = ""; $vat_number = ""; $is_vat_valid = false; $use_taxes = true;
	  
			// get taxes rates
			$tax_available = false; $tax_percent = 0; $tax_name = "";	$tax_cost = 0;
			if ($use_taxes) {
				$tax_rates = get_tax_rates(true, $country_code, $state_code, $postal_code);
				if (sizeof($tax_rates) > 0) {
					$tax_available = true;
					$tax_percent = $tax_rates[0];
					$tax_name = $tax_rates["tax_name"];
				}
			}
			$r->set_value("tax_name", $tax_name);
			$r->set_value("tax_percent", $tax_percent);

			// calculate summary for order
			$total_buying = 0;
			$total_merchants_commission = 0; 
			$total_affiliate_commission = 0;
			$goods_total = 0; $goods_taxable = 0; $goods_tax_total = 0;
			$total_quantity	= 0; $weight_total = 0;
			$total_discount = 0; $total_discount_tax = 0;
			$properties_total = 0; $properties_taxable = 0;
			$order_total = 0;
			
			//$total_discount = 0; $total_discount_tax = 0;
			//$properties_total = 0; $properties_taxable = 0;
	  
			for($i = 0; $i < sizeof($order_items); $i++)
			{
				$order_item = $order_items[$i];
	  
				$item_type_id = $order_item["item_type_id"];
				$buying_price = $order_item["buying_price"];
				$affiliate_commission = $order_item["affiliate_commission"];
				$merchant_commission = $order_item["merchant_commission"];
				$price = $order_item["price"];
				$item_tax_free = $order_item["tax_free"];
				$item_tax_percent = $order_item["tax_percent"];
				if ($tax_free) { 
					$item_tax_free = $tax_free; 
					$order_items[$i]["tax_free"] = $tax_free;
					$order_items[$i]["tax_percent"] = 0;
				}

				$weight = $order_item["weight"];
				$quantity = $order_item["quantity"];
	    
				$total_buying += ($buying_price * $quantity);
				$total_merchants_commission += ($buying_price * $merchant_commission);
				$total_affiliate_commission += ($buying_price * $affiliate_commission);
				$item_total = $price * $quantity;
				$goods_total += $item_total;
				if ($item_tax_free != 1) {
					$goods_taxable += $item_total;
				}
	  
				if ($tax_available && !$item_tax_free) {
					$item_tax = get_tax_amount($tax_rates, $item_type_id, $item_total, $item_tax_free);
					list($item_tax_percent, $item_tax_total) = $item_tax;
					$goods_tax_total += $item_tax_total;
					$order_items[$i]["tax_free"] = $item_tax_free;
					$order_items[$i]["tax_percent"] = $item_tax_percent;
				}
	    
				$total_quantity += $quantity;
				$weight_total += ($weight * $quantity);
	  
			}
	  
			// check the order total information
			$tax_total = $goods_tax_total;
			$order_total = $goods_total + $goods_tax_total;

			if ((strlen($fee_max_goods) && $goods_total > $fee_max_goods) || $goods_total < $fee_min_goods) {
				$processing_fee = 0;
			} else if ($fee_type == 1) {
				$processing_fee = round(($order_total * $processing_fee) / 100, 2);
			} 

			$order_total += $processing_fee;
	  
			$r->set_value("total_buying", $total_buying);
			$r->set_value("total_merchants_commission", $total_merchants_commission);
			$r->set_value("total_affiliate_commission", $total_affiliate_commission);
			$r->set_value("goods_total", $goods_total);
			$r->set_value("goods_taxable", $goods_taxable);
			$r->set_value("total_quantity", $total_quantity);
			$r->set_value("weight_total", $weight_total);
			$r->set_value("tax_total", $tax_total);
			$r->set_value("processing_fee", $processing_fee);
			$r->set_value("order_total", $order_total);

			// insert recurring order
			if ($db_type == "postgre") {
				$new_order_id = get_db_value(" SELECT NEXTVAL('seq_" . $table_prefix . "orders') ");
				$r->change_property("order_id", USE_IN_INSERT, true);
				$r->set_value("order_id", $new_order_id);
			}
			$order_placed_date = va_time();
			$order_placed_date_string = va_date($datetime_show_format, $order_placed_date);
			$r->set_value("order_placed_date", $order_placed_date);

			if($r->insert_record()) 
			{
				if ($db_type == "mysql") {
					$new_order_id = get_db_value(" SELECT LAST_INSERT_ID() ");
					$r->set_value("order_id", $new_order_id);
				} else if ($db_type == "access") {
					$new_order_id = get_db_value(" SELECT @@IDENTITY ");
					$r->set_value("order_id", $new_order_id);
				}

				// add orders items
				for($i = 0; $i < sizeof($order_items); $i++)
				{
					$order_item = $order_items[$i];
					$order_item_id = $order_item["order_item_id"];

					$oi->set_value("parent_order_item_id", $order_item_id);
					$oi->set_value("order_id", $new_order_id);

					$oi->set_value("item_id", $order_item["item_id"]);
					$oi->set_value("parent_item_id", $order_item["parent_item_id"]);
					$oi->set_value("item_user_id", $order_item["item_user_id"]);
					$oi->set_value("affiliate_user_id", $order_item["affiliate_user_id"]);
					$oi->set_value("item_type_id", $order_item["item_type_id"]);
					$oi->set_value("manufacturer_code", $order_item["manufacturer_code"]);
					//$oi->set_value("coupons_ids", $order_item["coupons_ids"]);
					$oi->set_value("item_name", $order_item["item_name"]);
					$oi->set_value("item_properties", $order_item["item_properties"]);
					$oi->set_value("buying_price", $order_item["buying_price"]);
					$oi->set_value("real_price", $order_item["real_price"]);
					$oi->set_value("discount_amount", $order_item["discount_amount"]);
					$oi->set_value("price", $order_item["price"]);
					$oi->set_value("tax_free", $order_item["tax_free"]);
					$oi->set_value("tax_percent", $order_item["tax_percent"]);
					$oi->set_value("merchant_commission", $order_item["merchant_commission"]);
					$oi->set_value("affiliate_commission", $order_item["affiliate_commission"]);
					$oi->set_value("weight", $order_item["weight"]);
					$oi->set_value("quantity", $order_item["quantity"]);
					$oi->set_value("downloadable", $order_item["downloadable"]);
					//$oi->set_value("shipping_expecting_date", "");

					if ($db_type == "postgre") {
						$new_order_item_id = get_db_value(" SELECT NEXTVAL('seq_" . $table_prefix . "orders_items') ");
						$oi->change_property("order_item_id", USE_IN_INSERT, true);
						$oi->set_value("order_item_id", $new_order_item_id);
					}
	      
					if($oi->insert_record())
					{
						if($db_type == "mysql") {
							$new_order_item_id = get_db_value(" SELECT LAST_INSERT_ID() ");
							$oi->set_value("order_item_id", $new_order_item_id);
						} else if ($db_type == "access") {
							$new_order_item_id = get_db_value(" SELECT @@IDENTITY ");
							$oi->set_value("order_item_id", $new_order_item_id);
						}
					}
				}
				// end of adding items

				$new_status_id = get_setting_value($recurring_settings, "new_status_id", "");
				$recurring_attempts = get_setting_value($recurring_settings, "recurring_attempts", 3);
				$recurring_next_attempt = get_setting_value($recurring_settings, "recurring_next_attempt", 1);
      
				// update recurring order status
				if ($new_status_id) {
					update_order_status($new_order_id, $new_status_id, false);
				}

				// prepare data for sending notifications
				$items_text = show_order_items($new_order_id, true);
				$r->set_parameters();

				// check notification for order creation
				$admin_notify_new = get_setting_value($recurring_settings, "admin_notify_new", 0);
				$user_notify_new  = get_setting_value($recurring_settings, "user_notify_new", 0);
				$admin_sms_new    = get_setting_value($recurring_settings, "admin_sms_new", 0);
				$user_sms_new     = get_setting_value($recurring_settings, "user_sms_new", 0);

				if ($admin_notify_new) {
					$admin_subject = get_setting_value($recurring_settings, "admin_mail_subject_new");
					$admin_message = get_setting_value($recurring_settings, "admin_mail_body_new");
					$admin_subject = get_translation($admin_subject);
					$admin_message = get_currency_message(get_translation($admin_message), $currency);
	    
					$t->set_block("admin_subject", $admin_subject);
					$t->set_block("admin_message", $admin_message);
	    
					$mail_to = get_setting_value($recurring_settings, "admin_mail_to_new", $settings["admin_email"]);
					$mail_to = str_replace(";", ",", $mail_to);
					$mail_from = get_setting_value($recurring_settings, "admin_mail_from_new", $settings["admin_email"]);
					$mail_cc = get_setting_value($recurring_settings, "admin_mail_cc_new");
					$mail_bcc = get_setting_value($recurring_settings, "admin_mail_bcc_new");
					$mail_reply_to = get_setting_value($recurring_settings, "admin_mail_reply_to_new");
					$mail_return_path = get_setting_value($recurring_settings, "admin_mail_return_path_new");
					$mail_type = get_setting_value($recurring_settings, "admin_mail_type_new");
					$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);
	    
					if (!$mail_type) {
						$t->set_var("basket", $items_text);
					} else {
						show_order_items($new_order_id, true);
					}
	      
					$t->parse("admin_subject", false);
					$t->parse("admin_message", false);
					$admin_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("admin_message"));
					mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
				}

				if ($user_notify_new)
				{
					$user_subject = get_setting_value($recurring_settings, "user_mail_subject_new");
					$user_message = get_setting_value($recurring_settings, "user_mail_body_new");
					$user_subject = get_translation($user_subject);
					$user_message = get_currency_message(get_translation($user_message), $currency);

					$t->set_block("user_subject", $user_subject);
					$t->set_block("user_message", $user_message);

					$mail_from = get_setting_value($recurring_settings, "user_mail_from_new", $settings["admin_email"]);
					$mail_cc = get_setting_value($recurring_settings, "user_mail_cc_new");
					$mail_bcc = get_setting_value($recurring_settings, "user_mail_bcc_new");
					$mail_reply_to = get_setting_value($recurring_settings, "user_mail_reply_to_new");
					$mail_return_path = get_setting_value($recurring_settings, "user_mail_return_path_new");
					$mail_type = get_setting_value($recurring_settings, "user_mail_type_new");
					$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

					if (!$mail_type) {
						$t->set_var("basket", $items_text);
					} else {
						show_order_items($new_order_id, true);
					}
	  
					$t->parse("user_subject", false);
					$t->parse("user_message", false);

					$user_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("user_message"));
					mail($user_email, $t->get_var("user_subject"), $user_message, $email_headers);
				}		 
			
				if ($admin_sms_new)
				{
					$admin_sms_recipient  = get_setting_value($recurring_settings, "admin_sms_recipient_new", "");
					$admin_sms_originator = get_setting_value($recurring_settings, "admin_sms_originator_new", "");
					$admin_sms_message    = get_setting_value($recurring_settings, "admin_sms_message_new", "");
	    
					$t->set_block("admin_sms_recipient",  $admin_sms_recipient);
					$t->set_block("admin_sms_originator", $admin_sms_originator);
					$t->set_block("admin_sms_message",    $admin_sms_message);
	    
					$t->set_var("basket", $items_text);
	    
					$t->parse("admin_sms_recipient", false);
					$t->parse("admin_sms_originator", false);
					$t->parse("admin_sms_message", false);
	    
					sms_send($t->get_var("admin_sms_recipient"), $t->get_var("admin_sms_message"), $t->get_var("admin_sms_originator"));
				}		 
	    
				if ($user_sms_new)
				{
					$user_sms_recipient  = get_setting_value($recurring_settings, "user_sms_recipient_new", $cell_phone);
					$user_sms_originator = get_setting_value($recurring_settings, "user_sms_originator_new", "");
					$user_sms_message    = get_setting_value($recurring_settings, "user_sms_message_new", "");
	    
					$t->set_block("user_sms_recipient",  $user_sms_recipient);
					$t->set_block("user_sms_originator", $user_sms_originator);
					$t->set_block("user_sms_message",    $user_sms_message);
	    
					$t->set_var("basket", $items_text);
	    
					$t->parse("user_sms_recipient", false);
					$t->parse("user_sms_originator", false);
					$t->parse("user_sms_message", false);
	    
					sms_send($t->get_var("user_sms_recipient"), $t->get_var("user_sms_message"), $t->get_var("user_sms_originator"));
				}

				$payment_type = "new";
				if ($recurring_method == 2 && $is_advanced && strlen($advanced_php_lib)) {
					$post_parameters = ""; $payment_parameters = array(); $pass_parameters = array(); $pass_data = array();
					get_payment_parameters($new_order_id, $payment_parameters, $pass_parameters, $post_params, $pass_data);

					$success_message = ""; $error_message = ""; $pending_message = ""; $transaction_id = "";
					// use foreign php library to handle transaction
					if (file_exists($root_folder_path . $advanced_php_lib)) {
						include ($root_folder_path . $advanced_php_lib);
					} else {
						$error_message = "Can't find appropriative php library: " . $advanced_php_lib;
					}
	      
					if (strlen($error_message)) {
						$payment_type = "failure";
						$order_status = $failure_status_id;
					} else if (strlen($pending_message)) {
						$payment_type = "pending";
						$order_status = $pending_status_id; 
					} else {
						$payment_type = "success";
						$order_status = $success_status_id; 
					}

					$sql  = " UPDATE " . $table_prefix . "orders ";
					$sql .= " SET error_message=" . $db->tosql($error_message, TEXT) ;
					$sql .= " , pending_message=" . $db->tosql($pending_message, TEXT);
					$sql .= " , success_message=" . $db->tosql($success_message, TEXT);
					$sql .= " , transaction_id=" . $db->tosql($transaction_id, TEXT);
					$sql .= " , is_placed=1 ";
					$sql .= " WHERE order_id=" . $db->tosql($new_order_id, INTEGER) ;
					$db->query($sql);
					
					// update order status for payment
					update_order_status($new_order_id, $order_status, false);

					// check notification for order payment
					$admin_notify_new = get_setting_value($recurring_settings, "admin_notify_" . $payment_type, 0);
					$user_notify_new  = get_setting_value($recurring_settings, "user_notify_" . $payment_type, 0);
					$admin_sms_new    = get_setting_value($recurring_settings, "admin_sms_" . $payment_type, 0);
					$user_sms_new     = get_setting_value($recurring_settings, "user_sms_" . $payment_type, 0);

					if ($admin_notify_new) {
						$admin_subject = get_setting_value($recurring_settings, "admin_mail_subject_" . $payment_type);
						$admin_message = get_setting_value($recurring_settings, "admin_mail_body_" . $payment_type);
						$admin_subject = get_translation($admin_subject);
						$admin_message = get_currency_message(get_translation($admin_message), $currency);
	      
						$t->set_block("admin_subject", $admin_subject);
						$t->set_block("admin_message", $admin_message);
	      
						$mail_to = get_setting_value($recurring_settings, "admin_mail_to_" . $payment_type, $settings["admin_email"]);
						$mail_to = str_replace(";", ",", $mail_to);
						$mail_from = get_setting_value($recurring_settings, "admin_mail_from_" . $payment_type, $settings["admin_email"]);
						$mail_cc = get_setting_value($recurring_settings, "admin_mail_cc_" . $payment_type);
						$mail_bcc = get_setting_value($recurring_settings, "admin_mail_bcc_" . $payment_type);
						$mail_reply_to = get_setting_value($recurring_settings, "admin_mail_reply_to_" . $payment_type);
						$mail_return_path = get_setting_value($recurring_settings, "admin_mail_return_path_" . $payment_type);
						$mail_type = get_setting_value($recurring_settings, "admin_mail_type_" . $payment_type);
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);
	      
						if (!$mail_type) {
							$t->set_var("basket", $items_text);
						} else {
							show_order_items($new_order_id, true);
						}
	        
						$t->parse("admin_subject", false);
						$t->parse("admin_message", false);
						$admin_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("admin_message"));
						mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
					}
			  
					if ($user_notify_new)
					{
						$user_subject = get_setting_value($recurring_settings, "user_mail_subject_" . $payment_type);
						$user_message = get_setting_value($recurring_settings, "user_mail_body_" . $payment_type);
						$user_subject = get_translation($user_subject);
						$user_message = get_currency_message(get_translation($user_message), $currency);
			  
						$t->set_block("user_subject", $user_subject);
						$t->set_block("user_message", $user_message);
			  
						$mail_from = get_setting_value($recurring_settings, "user_mail_from_" . $payment_type, $settings["admin_email"]);
						$mail_cc = get_setting_value($recurring_settings, "user_mail_cc_" . $payment_type);
						$mail_bcc = get_setting_value($recurring_settings, "user_mail_bcc_" . $payment_type);
						$mail_reply_to = get_setting_value($recurring_settings, "user_mail_reply_to_" . $payment_type);
						$mail_return_path = get_setting_value($recurring_settings, "user_mail_return_path_" . $payment_type);
						$mail_type = get_setting_value($recurring_settings, "user_mail_type_" . $payment_type);
						$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);
			  
						if (!$mail_type) {
							$t->set_var("basket", $items_text);
						} else {
							show_order_items($new_order_id, true);
						}
	      
						$t->parse("user_subject", false);
						$t->parse("user_message", false);
			  
						$user_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("user_message"));
						mail($user_email, $t->get_var("user_subject"), $user_message, $email_headers);
					}		 
			  
					if ($admin_sms_new)
					{
						$admin_sms_recipient  = get_setting_value($recurring_settings, "admin_sms_recipient_" . $payment_type, "");
						$admin_sms_originator = get_setting_value($recurring_settings, "admin_sms_originator_" . $payment_type, "");
						$admin_sms_message    = get_setting_value($recurring_settings, "admin_sms_message_" . $payment_type, "");
	      
						$t->set_block("admin_sms_recipient",  $admin_sms_recipient);
						$t->set_block("admin_sms_originator", $admin_sms_originator);
						$t->set_block("admin_sms_message",    $admin_sms_message);
	      
						$t->set_var("basket", $items_text);
	      
						$t->parse("admin_sms_recipient", false);
						$t->parse("admin_sms_originator", false);
						$t->parse("admin_sms_message", false);
	      
						sms_send($t->get_var("admin_sms_recipient"), $t->get_var("admin_sms_message"), $t->get_var("admin_sms_originator"));
					}		 
	      
					if ($user_sms_new)
					{
						$user_sms_recipient  = get_setting_value($recurring_settings, "user_sms_recipient_" . $payment_type, $cell_phone);
						$user_sms_originator = get_setting_value($recurring_settings, "user_sms_originator_" . $payment_type, "");
						$user_sms_message    = get_setting_value($recurring_settings, "user_sms_message_" . $payment_type, "");
	      
						$t->set_block("user_sms_recipient",  $user_sms_recipient);
						$t->set_block("user_sms_originator", $user_sms_originator);
						$t->set_block("user_sms_message",    $user_sms_message);
	      
						$t->set_var("basket", $items_text);
	      
						$t->parse("user_sms_recipient", false);
						$t->parse("user_sms_originator", false);
						$t->parse("user_sms_message", false);
	      
						sms_send($t->get_var("user_sms_recipient"), $t->get_var("user_sms_message"), $t->get_var("user_sms_originator"));
					}
				}
				// update next payment date 
				$current_date = va_time();
				$current_ts = mktime (0, 0, 0, $current_date[MONTH], $current_date[DAY], $current_date[YEAR]);
				for($i = 0; $i < sizeof($order_items); $i++)
				{
					$is_recurring = 1;
					$order_item_id = $order_item["order_item_id"];
					$recurring_period = $order_item["recurring_period"];
					$recurring_interval = $order_item["recurring_interval"];
					$recurring_plan_payment = $order_item["recurring_plan_payment"];
					$recurring_payments_failed = $order_item["recurring_payments_failed"];

					if ($payment_type == "failure") {
						$recurring_payments_failed++;
						$recurring_next_ts = mktime (0, 0, 0, $current_date[MONTH], $current_date[DAY] + $recurring_next_attempt, $current_date[YEAR]);
						if ($recurring_payments_failed > $recurring_attempts) {
							$is_recurring = 0;
						}
						$sql  = " UPDATE " . $table_prefix . "orders_items SET ";
						$sql .= " recurring_payments_failed=" . $db->tosql($recurring_payments_failed, INTEGER) . ", ";
						$sql .= " recurring_next_payment=" . $db->tosql($recurring_next_ts, DATETIME) . ", ";
						$sql .= " is_recurring=" . $db->tosql($is_recurring, INTEGER);
						$sql .= " WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
					} else {

						if ($recurring_period == 1) {
							$recurring_plan_ts = mktime (0, 0, 0, $recurring_plan_payment[MONTH], $recurring_plan_payment[DAY] + $recurring_interval, $recurring_plan_payment[YEAR]);
						} elseif ($recurring_period == 2) {
							$recurring_plan_ts = mktime (0, 0, 0, $recurring_plan_payment[MONTH], $current_date[DAY] + ($recurring_interval * 7), $recurring_plan_payment[YEAR]);
						} elseif ($recurring_period == 3) {
							$recurring_plan_ts = mktime (0, 0, 0, $recurring_plan_payment[MONTH] + $recurring_interval, $recurring_plan_payment[DAY], $recurring_plan_payment[YEAR]);
						} else {
							$recurring_plan_ts = mktime (0, 0, 0, $recurring_plan_payment[MONTH], $recurring_plan_payment[DAY], $recurring_plan_payment[YEAR] + $recurring_interval);
						}
						$recurring_next_ts = $recurring_plan_ts;
						if ($current_ts >= $recurring_next_ts) {
							$recurring_next_ts = mktime (0, 0, 0, $current_date[MONTH], $current_date[DAY] + 1, $current_date[YEAR]);
						}
				  
						$sql  = " UPDATE " . $table_prefix . "orders_items SET ";
						$sql .= " recurring_next_payment=" . $db->tosql($recurring_next_ts, DATETIME);
						$sql .= " WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
					}
					// update next payment date
					$db->query($sql);
				}

			} else {
				$recurring_error = true;
				$error_subject = "RECURRING DATABASE ERROR";
				$error_body = "Can't add a new recurring order." . $eol;
			}

/*
  //order_id, parent_order_id, transaction_id
  //success_message, pending_message, error_message
  //coupons_ids
  //total_discount, total_discount_tax
  shipping_type_id, shipping_type_desc, shipping_cost, shipping_taxable, shipping_tracking_id, shipping_expecting_date
  properties_total, properties_taxable
  tax_total, order_total
//*/
		}

	} else {
		$recurring_error = true;
		$error_subject = "RECURRING ORDER ERROR";
		$error_body = "Parent order wasn't found in database." . $eol;
	}
	
	if ($recurring_error) {
		$recurring_errors .= PARENT_ORDER_NUMBER_MSG . ": " . $parent_order_id . " " . $error_body . "<br>";

		// check for errors
		$error_body .= PARENT_ORDER_NUMBER_MSG . ": " . $parent_order_id . $eol;
		mail($recipients, $error_subject, $error_body, $email_headers);
	} else {
		$orders_added++;
	}

	// clear error flag and order_items array
	$order_items = array();
}
	
?>