<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  admin_support_rank.php                                   ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                 ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("support_users_priorities");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_support_rank.html");

	$t->set_var("admin_support_href", "admin_support.php");
	$t->set_var("admin_support_rank_href",  "admin_support_rank.php");
	$t->set_var("admin_support_ranks_href", "admin_support_ranks.php");

	$r = new VA_Record($table_prefix . "support_users_priorities");
	$r->return_page = "admin_support_ranks.php";

	$r->add_where("user_priority_id", INTEGER);

	$r->add_textbox("user_id", INTEGER, "Customer ID");
	$r->add_textbox("user_email", TEXT, "Customer Email");
	$r->change_property("user_email", USE_SQL_NULL, false);
	$r->change_property("user_email", REGEXP_MASK, EMAIL_REGEXP);
	$support_priorities = get_db_values("SELECT priority_id, priority_name FROM " . $table_prefix . "support_priorities", array(array("", "Select Priority")));
	$r->add_select("priority_id", INTEGER, $support_priorities, "Priority");
	$r->change_property("priority_id", REQUIRED, true);

	$r->set_event(BEFORE_VALIDATE, "user_priority_validation");
	$r->set_event(BEFORE_INSERT, "user_priority_update");
	$r->set_event(BEFORE_UPDATE, "user_priority_update");
	$r->set_event(AFTER_SELECT, "user_priority_select");

	$r->process();

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_href", "admin.php");
	$t->pparse("main");

	function user_priority_validation()
	{
		global $r, $db, $table_prefix;
		if ($r->is_empty("user_id") && $r->is_empty("user_email")) {
			$r->change_property("user_email", REQUIRED, true);
		}
	}

	function user_priority_update()
	{
		global $r, $db, $table_prefix;

		if ($r->is_empty("user_id")) {
			$r->set_value("user_id", "0");
		}
	}

	function user_priority_select()
	{
		global $r, $db, $table_prefix;

		if ($r->get_value("user_id") == "0") {
			$r->set_value("user_id", "");
		}
	}

?>