<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                       ***
  ***      File:  block_products_latest.php                                ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                 ***
  ***                                                                      ***
  ****************************************************************************
*/


function products_latest($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings;
	global $date_show_format;
	global $language_code;
	global $currency_left, $currency_right, $currency_rate;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$t->set_file("block_body", "block_products_latest.html");
	$t->set_var("lp_rows", "");
	$t->set_var("lp_cols", "");

	$user_info = get_session("session_user_info");
	$user_tax_free = get_setting_value($user_info, "tax_free", 0);
	$discount_type = get_session("session_discount_type");
	$discount_amount = get_session("session_discount_amount");
	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");
	$records_per_page = get_setting_value($page_settings, "products_latest_recs", 10);
	$display_products = get_setting_value($settings, "display_products", 0);
	$product_no_image = get_setting_value($settings, "product_no_image", "");
	$prod_latest_image = get_setting_value($page_settings, "prod_latest_image",  0);
	$prod_latest_desc = get_setting_value($page_settings, "prod_latest_desc", 0);

	$user_id = get_session("session_user_id");		
	$user_type_id = get_session("session_user_type_id");
	$price_type = get_session("session_price_type");
	if ($price_type == 1) {
		$price_field = "trade_price";
		$sales_field = "trade_sales";
	} else {
		$price_field = "price";
		$sales_field = "sales_price";
	}
	$image_field = ""; $image_alt_field = ""; $desc_field = "";
	if ($prod_latest_image == 1) {
		$image_field = "tiny_image";
		$image_alt_field = "tiny_image_alt";
	} else if ($prod_latest_image == 2) {
		$image_field = "small_image";
		$image_alt_field = "small_image_alt";
	} else if ($prod_latest_image == 3) {
		$image_field = "big_image";
		$image_alt_field = "big_image_alt";
	} else if ($prod_latest_image == 4) {
		$image_field = "super_image";
		$image_alt_field = "big_image_alt";
	}
	if ($prod_latest_desc == 1) {
		$desc_field = "short_description";
	} else if ($prod_latest_desc == 2) {
		$desc_field = "full_description";
	} else if ($prod_latest_desc == 3) {
		$desc_field = "features";
	} else if ($prod_latest_desc == 4) {
		$desc_field = "special_offer";
	}

	$sql  = " SELECT i.item_id, i.item_type_id, i.item_name, i.friendly_url, i.issue_date, ";
	$sql .= " i.buying_price, i." . $price_field . ", i.properties_price, i." . $sales_field . ", i.is_sales, i.tax_free, ";
	$sql .= " ip.price AS user_price, ip.discount_action AS user_price_action ";
	if ($image_field) { $sql .= " , i." . $image_field; }
	if ($image_alt_field) { $sql .= " , i." . $image_alt_field; }
	if ($desc_field) { $sql .= " , i." . $desc_field; }
	$sql .= " FROM ((" . $table_prefix . "items i ";
	$sql .= " LEFT JOIN " . $table_prefix . "items_prices ip ON (i.item_id=ip.item_id AND ip.min_quantity=1 AND ip.user_type_id=" . $db->tosql($user_type_id, INTEGER) . ")) ";
	$sql .= " LEFT JOIN " . $table_prefix . "manufacturers m ON i.manufacturer_id=m.manufacturer_id) ";
	$sql .= " WHERE i.is_showing=1 AND i.is_approved=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0 OR i.hide_out_of_stock IS NULL)";
	$sql .= " AND i.issue_date IS NOT NULL AND i.issue_date<=" . $db->tosql(va_time(), DATETIME);
	$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
	$sql .= " ORDER BY i.issue_date DESC ";

	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = 1;
	$db->query($sql);
	if($db->next_record())
	{
		$latest_columns = get_setting_value($page_settings, "products_latest_cols", 1);
		$t->set_var("latest_column", (100 / $latest_columns) . "%");
		$latest_number = 0;
		do
		{
			$latest_number++;
			$item_id = $db->f("item_id");
			$item_type_id = $db->f("item_type_id");
			$item_name = get_translation($db->f("item_name"));
			$friendly_url = $db->f("friendly_url");
			$item_image = ""; $item_image_alt = ""; $item_desc = "";
			if ($image_field) {
				$item_image = $db->f($image_field);	
				$item_image_alt = $db->f($image_alt_field);	
				if (!$item_image) {
					$item_image = $product_no_image;
				}
			}
			if ($desc_field) {
				$item_desc = $db->f($desc_field);	
			}
		
			if($item_image)
			{
				if (preg_match("/^http\:\/\//", $item_image)) {
					$image_size = "";
				} else {
	        $image_size = @GetImageSize($item_image);
					if (isset($restrict_products_images) && $restrict_products_images) { $item_image = "image_show.php?item_id=".$item_id."&type=small"; }
				}
				if (!strlen($item_image_alt)) { $item_image_alt = $item_name; }
        $t->set_var("alt", htmlspecialchars($item_image_alt));
        $t->set_var("src", htmlspecialchars($item_image));
				if(is_array($image_size)) {
	        $t->set_var("width", "width=\"" . $image_size[0] . "\"");
  	      $t->set_var("height", "height=\"" . $image_size[1] . "\"");
				} else {
	        $t->set_var("width", "");
  	      $t->set_var("height", "");
				}
				$t->sparse("lp_image", false);
			} else {
				$t->set_var("lp_image", "");
			}
			if ($item_desc) {
				$t->set_var("desc_text", $item_desc);
				$t->sparse("lp_desc", false);
			} else {
				$t->set_var("lp_desc", "");
			}

			$t->set_var("item_id", $item_id);
			$t->set_var("item_name", $item_name);
			if ($friendly_urls && $friendly_url) {
				$t->set_var("details_url", $friendly_url . $friendly_extension);
			} else {
				$t->set_var("details_url", "product_details.php?item_id=" . $item_id);
			}

			if ($display_products != 2 || strlen($user_id)) {
				$price = $db->f($price_field);
				$is_sales = $db->f("is_sales");
				$sales_price = $db->f($sales_field);
				if ($is_sales && $sales_price > 0) {
					$price = $sales_price;
				}
				$buying_price = $db->f("buying_price");
				$user_price = $db->f("user_price");
				$user_price_action = $db->f("user_price_action");
				$properties_price = $db->f("properties_price");
				if ($user_price > 0 && ($user_price_action > 0 || !$discount_type)) {
					$price = $user_price;
				}

				$tax_free = $db->f("tax_free");
				if ($user_tax_free) { $tax_free = $user_tax_free; }
				if ($user_price_action != 1) {
					if ($discount_type == 1 || $discount_type == 3) {
						$price -= round(($price * $discount_amount) / 100, 2);
					} else if ($discount_type == 2) {
						$price -= round($discount_amount, 2);
					} else if ($discount_type == 4) {
						$price -= round((($price - $buying_price) * $discount_amount) / 100, 2);
					}
				}
				// add options and components prices
				$price += $properties_price;
				$price = $price * $currency_rate;
		  
				set_tax_price($item_id, $item_type_id, $price, 0, $tax_free, "lp_price", "", "lp_tax_price", false);

				$t->sparse("lp_price_block", false);
			}

			$issue_date = $db->f("issue_date", DATETIME);
			$issue_date_string  = va_date($date_show_format, $issue_date);
			$t->set_var("issue_date", $issue_date_string);

			$t->parse("lp_cols");
			if($latest_number % $latest_columns == 0)
			{
				$t->parse("lp_rows");
				$t->set_var("lp_cols", "");
			}
			
		} while ($db->next_record());              	

		if ($latest_number % $latest_columns != 0) {
			$t->parse("lp_rows");
		}

		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>