<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  manuals.php                                              ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./includes/common.php");
	include_once ("./includes/navigator.php");
	include_once ("./includes/tree.php");
	include_once ("./includes/record.php");
	include_once ("./includes/editgrid.php");
	include_once ("./messages/".$language_code."/cart_messages.php");
	include_once ("./messages/".$language_code."/reviews_messages.php");
	include_once ("./messages/".$language_code."/support_messages.php");
	include_once ("./messages/".$language_code."/manuals_messages.php");
	include_once ("./messages/".$language_code."/messages.php");

	// include blocks
	include_once ("./block_articles_categories.php");
	include_once ("./block_articles_breadcrumb.php");
	include_once ("./block_articles_list.php");
	include_once ("./block_articles_category.php");
	include_once ("./block_articles_latest.php");
	include_once ("./block_articles_top_rated.php");
	include_once ("./block_articles_top_viewed.php");
	include_once ("./block_articles_hot.php");
	include_once ("./block_articles_content.php");
	include_once ("./block_articles_search.php");
	include_once ("./block_custom.php");
	include_once ("./block_banners.php");
	include_once ("./block_poll.php");

	$page_name = "manuals_list";
	$page_settings = va_page_settings($page_name, 0);

	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main","manuals.html");
	$t->set_var("current_href", "manuals.php");

	include_once ("./header.php");


	if(is_array($page_settings)) {
		foreach($page_settings as $setting_name => $setting_value)
		{
			if (preg_match("/^a_cats_(\d+)$/", $setting_name, $matches)) {
				articles_categories($setting_value, $matches[1], $top_name, "a_cats", $category_id);
			} else if (preg_match("/^a_subcats_(\d+)$/", $setting_name, $matches)) {
				articles_categories($setting_value, $matches[1], $top_name, "a_subcats", $category_id);
			} else if (preg_match("/^a_breadcrumb_(\d+)$/", $setting_name, $matches)) {
				articles_breadcrumb($setting_value, $matches[1], $rss_on_breadcrumb);
			} else if (preg_match("/^a_list_(\d+)$/", $setting_name, $matches)) {
				articles_list($setting_value, $matches[1], $list_fields, $articles_order_column, $articles_order_direction, $current_category, $list_template);
			} else if (preg_match("/^a_cat_desc_(\d+)$/", $setting_name, $matches)) {
				articles_category($setting_value, $category_id, $current_category, $full_description, $image_large, $image_large_alt);
			} else if (preg_match("/^a_latest_(\d+)$/", $setting_name, $matches)) {
				articles_latest($setting_value, $matches[1], $top_name);
			} else if (preg_match("/^a_top_rated_(\d+)$/", $setting_name, $matches)) {
				articles_top_rated($setting_value, $matches[1], $top_name);
			} else if (preg_match("/^a_top_viewed_(\d+)$/", $setting_name, $matches)) {
				articles_top_viewed($setting_value, $matches[1], $top_name);
			} else if (preg_match("/^a_hot_(\d+)$/", $setting_name, $matches)) {
				articles_hot($setting_value, $matches[1], $top_name, $list_fields, $articles_order_column, $articles_order_direction, $category_id);
			} else if (preg_match("/^a_content_(\d+)$/", $setting_name, $matches)) {
				articles_content($setting_value, $matches[1], $category_id, $current_category, $articles_order_column, $articles_order_direction);
			} else if (preg_match("/^a_search_(\d+)$/", $setting_name, $matches)) {
				articles_search($setting_value, $matches[1], $top_name, $category_id);
			} else if ($setting_name == "cart_block") {
				include_once ("./block_cart.php");
				small_cart($setting_value);
			} else if ($setting_name == "login_block") {
				login_form($setting_value);
			} else if ($setting_name == "subscribe_block") {
				include_once ("./block_subscribe.php");
				subscribe_form($setting_value);
			} else if ($setting_name == "sms_test_block") {
				include_once ("./block_sms_test.php");
				sms_test_form($setting_value);
			} else if ($setting_name == "poll_block") {
				poll_form($setting_value);
			} else if ($setting_name == "language_block") {
				include_once ("./block_language.php");
				language_form($setting_value, $page_settings["language_selection"]);
			} else if ($setting_name == "currency_block") {
				include_once ("./block_currency.php");
				currency_form($setting_value);
			} else if (preg_match("/^navigation_block_(\d+)$/", $setting_name, $matches)) {
				include_once("./block_navigation.php");
				navigation_menu($setting_value, $matches[1]);
			} else if (preg_match("/^custom_block_/", $setting_name)) {
				custom_block($setting_value, substr($setting_name, 13));
			} else if (preg_match("/^banners_group_/", $setting_name)) {
				banners_group($setting_value, substr($setting_name, 14));
			} elseif ($setting_name == "manuals_list") {
				include_once ("./block_manuals_list.php");
				manuals_list($setting_value);
			} else if ($setting_name == "manuals_search") {
				include_once ("./block_manuals_search.php");
				manuals_search($setting_value);
			} else if ($setting_name == "manuals_breadcrumb") {
				include_once ("./block_manuals_breadcrumb.php");
				manuals_breadcrumb($setting_value);				
			}
		}
	}

	if(!get_setting_value($page_settings, "left_column_hide", 0)) {
		$t->set_var("left_column_width", get_setting_value($page_settings, "left_column_width", "20%"));
		$t->parse("left_column", false);
	}
	if(!get_setting_value($page_settings, "middle_column_hide", 0)) {
		$t->set_var("middle_column_width", get_setting_value($page_settings, "middle_column_width", "60%"));
		$t->parse("middle_column", false);
	}
	if(!get_setting_value($page_settings, "right_column_hide", 0)) {
		$t->set_var("right_column_width", get_setting_value($page_settings, "right_column_width", "20%"));
		$t->parse("right_column", false);
	}

	include_once ("./footer.php");

	$t->pparse("main");
?>